### Eddie is free, but ...

Eddie is a freeware application. If you have suggestions, feature requests, bug reports or just find Eddie useful, please send me a note to <pavel@el34.com>. For crash reports please include a backtrace/crash reporter log and a brief description of what you were doing when you experienced the crash, if possible.

Crash reports can be copied from the CrashReporter window or can be found as
individual files at:

`~/Library/Logs/DiagnosticReports/Eddie*.crash`

or

`~/Library/Logs/CrashReporter/Eddie*.crash`

on older systems.

Your feedback directly inspires making Eddie an even more useful tool in the future!

Make sure to check out the documentation accessible through the Help menu.

#### Changes by version:

##### Version 3.4.5
* Big Sur compatibility fixes:
  * Fix ReplaceAll
  * Fix a bug where opened documents would sometimes get touched
  * Fix various list drawing inconsistencies
* Saved searches: Allow saving/restoring Find window state
* Open/Save panel reliable initial directory setup
* Wrapped super large document window resize SPOD
* Prototyper handling of modern intializer lists
* Swift function popup parser fixes
* Swift syntax coloring recursive string interpolation/nested string handling
* Fix a bug with Status window hex dump of multi-byte UTF-8
* Python FP - fix a bug with docstring messing up indent parsing

##### Version 3.4.4
* Status window tweaks: Add line numbers for multi-selection.
* Made Indexer correctly find libc++ headers even if Xcode is renamed.
* Obj-C Indexing fixes
* Prototyper, Syntax Coloring and Function Popup handling of user defined C++ literals/literal operators.
* Fixed several bugs in prototyper settings.
* Made Preference panes larger to fit new toolbar layout.
* Enable Edit menu items correctly when showing Save panel.
* Fixed a SPOD when Find panel is showing over a super huge document.
* Fixed a bug in Find window multi-pane settings persistence 
* Awk syntax coloring
* Fixed Ifdef balancer menu matching item selection

##### Version 3.4.3
* Fixed a problem where Indent Right was inserting tabs to empty lines.
* Don't draw stray whitespace inside quoted strings.
* Fix a problem where red was sometimes drawing from a stray whitespace to an adjoining string.
* Improved Prototyper C++ parsing.
* Improved Indexer C++ parsing.
* Improved Function Popup C++ parsing.
* Improved Syntax Coloring C++ parsing.
* Improved Syntax Coloring Make parsing.
* Fix ToDo in swift code messing up function popup.
* Fix crashes closing tabs added as inactive by reordering in Document Window.
* Fix SFTP/Open From server unknown server handling and unknown file path handling.
* SFTP Open - add a user dialog if none supplied in url
* SFTP Open better connecting state flow
* Command-D now works on urls
* Command-D of an sftp url gets opened by Eddie
* Better window resizing behavior when using wrap to window frame

##### Version 3.4.2
* Worked around a Catalina scroll view bug that sometimes leaves portions of view undrawn
* Fix a few bugs related to having spaces in the home directory path
* Fix glitches in git commit spew handling

##### Version 3.4.1
* Fix occasional deadlock in Show Definition window
* Fix "Reopen in Preferred Editor"
* Fix Find window buttons not enabling after inserting a tab
* Fix a problem with indexing generating path cache on volumes mounted in paths different than /Volumes
* Fix a lock up in ExtendOrShrinkToWordLeft
* Fix Shell/Worksheet problems when running Eddie from a path that contains spaces
* Fix a bug where converting a document containing long utf8 chars to Roman would corrupt the rest of the document
* Fix Services menu items

##### Version 3.4
* Swift
   * - Indexing/auto completion beta
   * - Function popup parsing improvements
   * - Syntax coloring improvements
   * - Fixed quote balancing
* C++
   * - Indexing/auto completion fixes
   * - Tweaked commenter logic to better handle a selection of both commented and non-commented lines
   * - Indenter fixes
* Golang
   * - Added syntax coloring
   * - Added function popup
* Markdown
   * - Added syntax coloring
   * - Added function popup
* Find & Replace
   * - Fixed ".h & .c" Find window file type menu
   * - Fixed a problem where Replace All sometimes didn't work on first find
   * - Force Find window up during long, multi-file replacements
   * - Fixed number of problems with Replace All in multi-file find
   * - Allow Replace when selection matches find, not just if find just matched
   * - Properly color UTF8 search string in regex mode
* #ifdef balancer
   * - Outline all #ifdefs enclosing the current selection, not just the immediate one
* Function popup
   * - Made "MARKER: -" & friends properly emit a menu separator
* Split panes
   * - Better rendering of splitter thumb
   * - Better rendering of focus outline
   * - Properly update status bar when panes are split
* Misc fixes and improvements
   * - Added "Wrap selection by matching delimiters"
   * - Whitespace stripping improvements
   * - Per-filetype configurable stray whitespace showing
   * - Fix stray whitespace display in wrapped text
   * - Better handling of nbsp and other UTF8 chars
   * - Removed arbitrary limits on `$SELECTED_TEXT` in smart clipboards
   * - Made temporary shell execution resilient to initial spew from shell profile
* Crashes:
   * - Fixed a crash when opening an indexed document, after the parent folder of document moved
   * - Fixed a crash draging items around in Document list window on Mojave
   * - Fixed a crash during multi-file find after tearing out a tab
   * - Fixed some Catalina compatibility issues

##### Version 3.3.4
* Latest macOS compatibility
   * Fix over-scroll drawing
   * Fix drag&drop incompatibility
   * Fix a problem with blocking tellEddie not working
* Fix occasional crasher in Declaration dialog
* Fix occasional crasher in Open Quickly dialog
* Fix occasional crasher closing split pane
* Fix occasional crasher in Shell when emitting complex spew
* Fix Open Quickly menu item going dim
* Fix a bug with Workset window always opening on startup, once opened

##### Version 3.3.3
* Swift coloring
   * 4.0 support
   * Properly color generics
   * Fix recoloring bugs
* Antlr 4 support
* Bison coloring
* Fixed broken status rect.
* #ifdef balancer
   * context menu
   * Pick up symbols from edited document
* Tab completer spods
* Better password prompt detection
* Function popup -- better #if 0 handling
* Fix crash bringing up Find when shell is off
* Balancing, double clicking opening/closing quotes and kiss matching of Raw string quotes and @"" objc strings
* Option-click on items in secondary clipboard palette also pushes them to the main paste stack
* Fix shell function popup.
* Better shell syntax coloring (shell functions, arithmetic expansions)
* Prototyper
   * noexcept handling
* Indexer
   * lambda handling
   * better stl header indexing
   * other misc parsing fixes
* Indenter formatting Finder style function calls with comments inline
* Improved path truncation in lists
* Magnetic palettes
* Stable sorting of Open selection completion list
* Small fix to Find window checkboxes enabled state updating
* Properly recolor on save, if document type established
* Optional Auto-trimming of whitespace
* Trim Whitespace in selection command
* Show invisibles: option to show just stray whitespace
* Fixed drawing glitches with show invisibles on

##### Version 3.3.2
* Better Perl syntax coloring
* Better objc property and parameter attribute coloring
* Swift function popup and syntax coloring minor improvements
* Indexer better parsing
* Fix a problem where some irregular shell output caused shell to never complete emitting

##### Version 3.3.1
* Better url/password handling in SFTP/server open
* Make entering junk into the Go To Line dialog not break Eddie.
* Make large worksets not block the main thread
* Make large git repositories in a workset not cause a lot of extra idle CPU processing
* Fix ocasional crash on quit, closing a workset

##### Version 3.3
* Improved Find
   * Find In Next File now works even if multi-file search is off
   * Better handling of revealing multi-line match selection
* Document list window
   * Context menu
* tellEddie
   * Support for git commit (option to force selection to the top of the document)
* Better handling of shell failing to start executing menu commands
* Fix exceptions thrown by Font panel
* Indexer fixes:
   * Better handling of new deprecation macros
* Proper UTF-8 detection of documents containing control characters
* Hide tab bar after closing second tab
* Fix a bug with About window showing after launch on macOS Sierra
* Paste via Undiff command
* Fixed a crasher in split panes
* C++ indenter beta improvements
* Make Cmd-D work on git diff -- style paths
* Added more useful setup commands to default worksheet
* Made new shell tab correctly re-color on first draw
* Fixed source control status updating in Workset window
* pty setup robustness in tellEddie
* JSON syntax coloring
* Fix lockup in syntax coloring when starting to edit an empty makefile
* Commenter tweaks
* Swift syntax coloring improvements
* Shell improvements
   * Better ANSI escape code handling (git diff)
   * Do not pollute bash history

##### Version 3.2
* Fixed performance of colored shell output (xcodebuild)
* Fixed performance of syntax coloring updates in mega-huge files, notably html
* Undo of colored shell output doesn't strip ansii colors
* Fixed Indexer C++11 handling
* Fixed SFTP Open panel handling of ECDSA key change errors
* Swift function popup improvements
* SFTP Open panel -- draw links to some well known folders as folders, not generic files.
* Color redundant spaces followed by a tab as stray invisibles
* Beta of C++ indenter
* Better support for backspaces in shell output
* Fixed ocasional crash when unsplitting split pane windows
* Added `$LINE_EXPANDED_SELECTED_TEXT` and `$WORD_EXPANDED_SELECTED_TEXT` smart clipboard symbolic value primitive
* Properly color final and override
* Added an "Open in Tab" context menu item to the workset
* Fixed keyboard type-ahead in the workset window
* Document list window improvements
* Bison function popup

##### Version 3.1
* Improved Balance and the double-click to balance command
   * -- compiler-like accuracy/correctness
   * -- full handling of quoting, comments and other language constructs
   * -- balancing of <> pairs, when possible
   * -- balancing of comments
* Bring back kiss matching
   * -- use the new accurate balancing engine for better correctness of matches
   * -- arrowing over balancable character flashes match
* Improved smart swap
   * -- understand C++11 initializer syntax and correctly swap initializers
   * -- correctly swap lambdas as function arguments
* Swift syntax coloring and function popup improvements
* Ragel syntax coloring and function popup improvements
* Python syntax coloring improvements
* C++ syntax coloring tweaks
* Find String preconfigured pattern menu can have optional keyboard shortcuts
* Fix "Traditional" prototyper theme to correctly emit static member prototypes
* Made executing python scripts not mess up worksheet termios
* Fixed SFTP Open panel sometimes not entering a selected directory
* Fixed a crash double clicking open panel row header
* Handle sftp:// URLs
* Made tab completion path cache less aggressive
* Fixed some crashes on quit
* Fixed some cases of runaway re-indexing
* Fix uncommenting of shell comments in Ragel sources

##### Version 3.0.2
* Fixed crash when opening selection while path cache was being loaded
* Syntax coloring:
   * Fix recoloring of #import <foo>

##### Version 3.0.1
* Quick fix for 10.9

##### Version 3
* Improved Find
   * Multi-find
   * Sped up Replace And Find
   * Simplified Multi File directory search path popup.
   * Added more source file types to type filter popup.
   * Multi File search now includes frontmost document, even though it's otherwise not included in the search list
* Improved Function Popup
   * Better #if branch handling
   * Proper handling of "#pragma mark - foo -"
   * Show everything in header files
   * Handling of C++11:
       * function return type syntax
       * rvalue refs
   * Obj-C @property handling
   * Handling of Obj-C methods with unnamed selectors
   * Show TODO, [TODO], FIXME as markers in popup
   * Ragel support
* Improved syntax coloring
   * Better C++14 handling
   * Better template class coloring
   * Better template function coloring
   * Better include coloring
   * Color TODO, [TODO], FIXME
   * Color Obj-C @properties
   * Handling of #if 1/#else blocks
   * Fixed recoloring when editing .css documents
* Clipboard enhancements
   * Clipboard History stack
   * Paste history menu for main clipboard
   * Paste from history for all clipboards via Context menu and clipboard popover windows
   * Paste history for all clipboards editable
   * Extended clipboards support smart paste entries with symbolic token expansion
   * Added keyboard primitives for first 6 entries in each clipboard
* Window list window
   * Allows fast selective closing of a bunch of windows
   * Allows fast grouping of windows into tabs
* Shell Tab Completion
   * Completions from the System headers now draw in dark green, distinct from local files
   * Hitting Tab for a third time will now attempt to complete a local directory completion, if possible
* Fixed symbol completion
   * Indexer enumerates paths using xcrun to better support SDK includes
* Ifdef balancer
   * balance makefiles
   * balance @interface @end
* Improved Line Number gutter
   * floats above text
   * offers line selection
* Commenter
   * Fixed some quirks when commenting and uncommenting shell files (and Python)
* TabView
   * Drop a tab on originating window opens as a new window
* User Menu commands
   * ensure directory is set to that of the active shell prior to executing a command
* Updated help/docs
* New look
* Fixed a problem with pane resize thumb sometimes showing for occluded windows
* Fixed SFTP open dialog size persistence
* Fixed SFTP open dialog failure to get file if list truncated
* Fix a bug where miniaturized windows would not get persisted across relaunches.

##### Version 2.5.9
* Added Show invisibles.
* Correctly invalidate open header cache via fsevents.
* Reworked selection display in various lists to use system selection colors.
* Fixed a bug in increase/decrease font size.
* Fixed a problem where Workset, SFTP Open, Prefs and other windows came up with an I beam cursor, sometimes.
* Refined tab completion to only use local completions when completing a single letter.
* Fixed tab completer to correctly append space (only when the completion is unique) and to properly
* not escape said space.
* Fixed menu updating and initial state capturing in the "Switch To Last Edit" feature.
* Opening new untitled documents now respects global "Show line numbers" setting.
* Fixed a bug where Find window regex error popup came up too narrow.
* Fixed a crash on quit when quitting while completion symbols are being loaded
* Fixed Server Open Panel size and date column resizing and name column truncation.
* Fixed a bug where activity in a shell in an inactive tab was causing declaration tip windows to close.
* Fixed a bug where active shell in an inactive tab wasn't scrolling to selection.
* Inactive tab active shell busy indicator sometimes wasn't spinning as it should.
* Fixed the Undiff command to properly paste back into the selection.
* Improved #ifdef branch handling in indexer.
* Fixed formatting of pasted declarations in Prototyper.

##### Version 2.5.8
* Swift syntax coloring and function popup
* Color ANSI terminal mode support in shell windows
* Improved pane splitting by dragging splitter thumb
* Added support for Services menu
* Added copy as breakpoint to Context menu

##### Version 2.5.7
* New Open Quickly dialog
* Syntax coloring and function popup: support new C++14 single quote number separators
* Fixed an occasional crash in reverse Find
* Made sorting of a huge selection not screw up
* Better quit loop

##### Version 2.5.6
* Improved HTML (Javascript, CSS, PHP) function coloring -- fixed lock-ups and coloring correctness
* Improved Python function popup
* Improved Java syntax coloring and function popup
* Added HTML, Javascript, CSS and PHP function popup
* Context-sensitive commenter feature -- selects the right comment style in multi-language documents
* Fixed an occasional crash auto-completing file path names in a parent directory
* Do not show iBeam over an active Find panel is active.
* Fix an occasional bug with Replace&Find in multi-file search not advancing to the correct next search result
* Fixed Lua commenter.

##### Version 2.5.5
* Much improved Lua syntax coloring
* Much improved Lua function popup
* Added Lua-style comments to commenter
* Fix Ruby syntax coloring to not lock up
* Much improved C/C++ function popup parser
   * C++11 support
   * including better template handling
   * Some parsing bugs and some improved ObjC class handling
* Add support for UTF-8 BOM encoding.
* Fix mixed up Replace/Find, Replace All and Replace In Selection buttons in Find
* Undo Replace All
* Fix an occasional crash if window closed after function popup and prototyper both get used
* Bring back "Leave Windows Open" checkbox to multi-file find options
* Fix an occasional lock up when using tabs with non-overlay scrollbars
* Fix an occasional crash when closing a split pane
* Fixed problems with interrupted shell output causing the Undo record to sometimes split up
* Made path name completion properly trigger tag rebuilding

##### Version 2.5.4
* Fix occasional crash on quit
* Pane split animation

##### Version 2.5.3
* RTF clipboard was not generated with correct unicode escaping
* Fix inaccurate line rendering at the end of super-huge (> 20MB) documents
* Toggle overlay/legacy scrollbars based on system preference, support pane splitting even with overlay scrollers
* Re-open documents in the same order from last quit
* New Untitled Shell template
* Make Python and Shell syntax coloring not flicker during edits
* Properly set terminal width based on window size
* Much improved symbol indexer
   * C++11 handling
   * Properly index new clang standard library headers
   * Python symbols
* Function popup improvements
   * Better template handling
   * Better new STL headers handling
* Fixed a bug in reading DOS format documents

##### Version 2.5.2
* Fix a problem with the "Editing" and "Colors" pref panes not displaying on 10.5 and 10.6.
* Fix a problem with selection stream pipes not getting deleted correctly on quit.

##### Version 2.5.1
* Python syntax coloring improvements (more robust with huge files, more correct)
* Shell syntax coloring improvements
* Ragel syntax coloring
* Python '"""' style headerdoc comment support in commenter
* Shell function popup
* Antlr syntax coloring and function popup
* Fix a crash when merging tabs
* Find window option to toggle "Dot matches '\n'" in regex searches
* Context menu in text editor
* Resizable Find window
* Recent/common find strings menu can now be pre-populated by favorite string patterns
* Improved function popup and prototyper function boundary detection
* Added support for svn 1.7 and later
* Fixed a problem with git integration that would cause excessive CPU use and memory leaks in some cases
* Properly draw tab completion windows with bold entries
* Added support for user menus in the form:

		AddEditUserMenu -name "Sort Selection in front window" -toSubmenu Commands -shellCommand "sort -f < $_AS > $AS_"
		AddEditUserMenu -name "Sort Selection in target" -toSubmenu Commands -shellCommand "sort -f < $_TS > $TS_"
		AddEditUserMenu -separator -toSubmenu Commands
		AddEditUserMenu -name "Today's date" -toSubmenu Commands -shellCommand "/bin/date +%e-%b-%Y" -shortcut Control-D
		AddContextUserMenu -name "Echo stuff" -shellCommand "echo stuff" -shortcut Command-Option-Y
		AddContextUserMenu -name "Echo into sel" -shellCommand "echo stuff > $AS_" -shortcut Command-Option-Y

* Added Eddie env variables `$ACTIVE`, `$_AS`, `$AS_`
* Temp shell password prompt
* Fix a bug in undo when undoing in a middle of long shell spew
* Added a simple undiff tool and a handful of other commands to the Edit menu

##### Version 2.5
* UTF-8 and input method support
* Improved Find
   * -- boost regex engine supporting Perl regular expression syntax
   * -- Regex find syntax coloring and error highlighting
   * -- auto-escaping of search strings when Regex enabled
   * -- Improved Forward/Reverse find advance in the presence of overlapping matches
   * -- Number of other find-related fixes and improvements
* Improved tabbed shell support
   * -- inactive shell tabs show busy progress while shell activity is going on
   * -- shell tabs in the Worksheet window are persisted
   * -- Fixed a crash using panes in tabs
* Improved symbol indexer
   * -- add support for C++11 "using" type definitions/declarations
   * -- add more availability macro symbols
* Improved code completion
   * -- Make it a little better about not stealing the down arrow key (you now have to press Ctrl-Down Arrow to focus the list).
   * -- Added a way to set a up a keyboard shortcut to select next in the completion popup (via the --tryFirst shortcut)
   * -- Made the first path completion when the "Use Symbols when Tab-completing" shortcut is on not cause a temporary SPOD
* Improved function prototyper
   * -- ObjC method prototypes automatically wrapped in @interface or @implementation where applicable
   * -- Whitespace applied lazily during paste -- you can now load up the prototyper clipboard, switch whitespace theme, paste the prototypes, the right thing will happen.
   * -- fixed handling of operator+, operator-
* Improved function popup
   * -- Made it handle forward interface and protocol declarations correctly
   * -- Fixed a bug where it didn't correctly indicate the position between two methods in the popup
* Improved syntax coloring
   * -- Speed up coloring of super-huge files
   * -- Fixed function coloring inside an extern "C++" block
   * -- Fixed function coloring of some templated functions
   * -- Few new color schemes
* Fixed horizontal scrollback sometimes fighting to scroll while using gesture scrolling
* Fixed tab drag image
* Fixed Ctrl-Click on a clipboard button
* Fixed a bug where extended clipboards were no longer saving themselves on quit.
* Fixed a bug where pasting styled text from Eddie to Mail sometimes pasted more than original selection
* Added --tryFirst SetKey keyboard shortcuts that run optionally before main shortcuts
* Wrong line terminators being added to the pasteboard.
* Fixed indent left right of a couple lines right at the document end

##### Version 2.4.2
* Color HTML escaped unicode glyph literals
* Color numeric constants
* Color functions
* Color classes
* Faster syntax coloring
* Ruby function popup
* Ruby syntax coloring correctness improvements
* When using split panes outline the focused pane, refine click-through behavior
* Draw blocky non-antialiased Monaco on Retina display
* Fix a bug where indexing paths entered in preferences were not being used
* Fix split panes not getting color changes updates properly
* Fix a crasher
* Fixed smart swap of initializer list items

##### Version 2.4.1
* Cmd-D uses shell directory to help find
* Color HTML escaped unicode glyph literals
* Fixed a crash in tabs
* Fixed a crash when spewing into an invisible tab
* Fixed a crash when Cmd-D was coming empty
* Fixed a crash when saving the worksheet directory when inactive/other tabs are open
* Improve the error alert when failing to open documents

##### Version 2.4
* Tabs
* Improved Window menu
* Faster indexer with improved C++ parsing
* Added an option to specify paths to exclude when indexing
* Open panel optionally shows hidden files
* Better handling of large git repositories
* Extended Cmd-D file:line detector to also understand file:line:column and file:line:startColumn:endColumn
* Added a global preference to toggle showing line numbers
* Defeated unhelpful quote substitution in Find window
* Enhanced the old "Go Back" command to offer a more general edit location navigation, supporting:
   * - Switch with last edit (previously Go Back)
   * - Go back in edit history
   * - Go forward in edit history
   * - The "Go Back" command now also switches between edits in different tabs, as appropriate
* Fixed the Shift-Tab shortcut
* Many other bug fixes
* New version of the tellEddie tool

##### Version 2.3.2
* Fixed Find menu crasher
* Added the ability to Execute a command in any document window
* Added menu item to toggle "Show Line Numbers" setting
* Add activate shell via Cmd-1..8 (analogous to existing Cmd-0 for Worksheet)
* Fixed a problem where "Wrap to window" sometimes wouldn't rewrap when toggling line numbers on/off
* Fixed incorrect line number display when "Wrap to window" enabled
* Fixed a problem with not being able to turn the "Use symbols while Tab-completing" preference off.
* Include Colors when copying test into the system clipboard
* Save shell window directories (previously already done for Worksheet)

	
##### Version 2.3.1
* tellEddie git support
* Fix a font menu crasher that happened with some third party fonts

##### Version 2.3
* Open/save to SFTP/SSH server
* Add an option to soft-wrap to window width
* Properly handle line numbers in wrapped documents
* Fix a crash when entering a super long search string using Cmd-E
* Added Cmd +/Cmd - Quick Font size increase/decrease shortcuts
* LaTeX syntax coloring and function popup.
* Symbol lookup - option to automatically generate and re-generate local and system tags
* Added support for some previously unhandled Obj-C constructs and header macros to symbol lookup indexer.
* Function popup handling of various header macros.
* Fix a problem with reloading documents in response to on-disk changes when local changes exist
* Fix scrollbars not updating correctly in split panes on Mac OSX Lion
* Shell path name tab completion uses paths from the indexer
* Handle accidental horizontal scroll
* Retina display support
* Add "In Open Windows" as an option to multi-file Find

##### Version 2.2
* Git support in Worksets
* Untitled workset didn't allow Save As
* Append .wkst suffix when saving worksets, if needed
* tellEddie -c automatically creates a .c/.h pair/boilerplate
* & was not properly escaped in shell path variables, caused confused Worksheets
* Properly display ssh upload progress in shell windows (support '\r' correctly).
* Properly handle backspace sequences in shell output.
* Smart swap improvements -- correctly handle quoted strings.
* Small fix to quote double-click balancing.
* Make Suggestions window close when invoking other keyboard commands
* Include syntax coloring colors in text drag
* Fix Page Up/Down keyboard shortcuts
* Handle quitting of unresponsive shell sessions better.

##### Version 2.1
* Added more Find shortcuts as menu items
* Properly handle multi-line shell commands/lists
* Show line numbers
* Don't scroll when you delete text at the end of the document.
* Fix a bug in the UpArrowSingleLineScroll primitive
* Fixed a crash when SizeWell is installed.
* Fixed a crash when closing Quick Find on Leopard.
* Multiple folders added to a workset through the Open Panel were not sorted correctly.
* Fixed a bug where reverse multi-file search wasn't searching from the end of a document
* Fixed a bug where reverse multi-file search wasn't wrapping correctly
* Faster loading of Worksets
* Fixed a leak in Worksets
* Fix a bug in the Find window "Leave windows open" setting
* Fix Multi-file reverse iterator and workset forward and reverse iterator.
* Make workset iterator properly iterate groups with no folder association
* Fix bug reading Windows (CRLF) documents.

##### Version 2.0
* Text drag & drop
* Many symbol/autocompletion fixes
* Many improvements and bug fixes in window pane splitting
* More robust multi-line shell execution and password prompt handling
* Many improvements to Symbol lookup/completion indexer
* More light-weight background document change handling
* Find Window
   * - Option to auto-close windows opened by multi-file search
   * - Option to filter folders to exclude from multi-file search
   * - Fixed crashes, lock-ups and other misc. bugs
* Improved Worksets
   * - SVN integration
   * - better drag&drop
   * - improved multi-level folder hierarchy support
   * - many bug fixes
* Improved support of exotic fonts
* Obj-C rewrite
* Mac OSX Leopard, Snow Leopard and Lion support (Intel 64 bit, Intel 32 bit, PPC)
* Many other bug fixes

Older versions:

##### Version 1.2.1
* Fix a crash when quitting with a read-only Worksheet
* Make man work in the Worksheet.
* Small tweaks in symbol/autocompletion parser
* Fix a problem where the Keypad period wasn't working.

##### Version 1.2

##### Version 1.1.2
* Symbol lookup:
   * Obj-C support for lookup and auto-completion
   * Improved C++ auto-completion
* Fixed redraw glitch when clicking the window zoom button.
* Fix some clipboard incompatibilities.
* Tab and Shift-Tab support for indenting.
   * Added a new TabOrIndentRight primitive (Cmd-Tab), Shift-Tab to IndentLeft.
* Separate keyboard maps for editor windows and shell windows.
* Better handling of quotes when using path Tab-completion
* Some enhancements to the smart swap function
* Made `$_TS` pipe handling more robust

##### Version 1.1.1
* Fix a crash when Find clipboard contains non-ASCII characters.
* Fix super-slow turning of syntax coloring in large documents.
* Obj-C support in the magic prototyper.
* Improvements to function popup Obj-C handling.
* Fix plugin problems on recent OSes.
* Open the Find panel and disclose the multi-find pane if search comes out empty.
* Tweak autoscroll behavior a tiny bit.
* Small fixes in Tab completion.

##### Version 1.1
* Python function popup.
* Commenter Python support.
* Ruby syntax coloring and commenter support.
* Added a "Tab inserts spaces" preference.
* Added a "Auto save Worksheet Path" preference.
* Exported TARGET selection to the shell as `$_TS` and `$TS_`
   * Selection in the TARGET window can now be addressed as a pipe in the Worksheet
   * You can now for instance do the following commands:
	"cat < $_TS"
			... to print the selection from your TARGET window into the Worksheet
	"date > $TS_"
			... to paste the date/time into your TARGET window
	"sort < $_TS > $TS_"
			... to sort selected lines in the TARGET window (great for sorting #includes, etc.)	
* Show full file paths in declaration popup windows when showing duplicate symbols
* Added a menu item to reopen all documents that were open at last quit.
* Resize the window to avoid the Dock after moving the window
* Status panel shows hex values of short selections
* Faster ReplaceAll.
* Fixed a crash in the colors pref pane
* Fixed pathname tab completion to understand env variables
* Use `~/.bash_logout` (if present) when quitting a shell or Worksheet
* Improved AutoIndent and ExtendOrShrinkToLineRight keyboard shortcuts
* Many other misc bug fixes


##### Version 1.0.1:
* Fixed default tab handling
* Fix a bug where $TARGET variable was empty
* Fix entering special characters such as Opt-8 (•)
	

##### Version 1.0
* Anti-aliased font support.
* New preferences:
   * - Flash highlighting of find selection on/off
   * - Keep Find window open
   * - Optional creator setting
* Color preferences pane:
   * - More color themes.
   * - Allow adding/editing user color themes.
* tellEddie has new options:
   * - -c to create and open a new file
   * - when opening from stdin, allow marking resulting document as temporary by
   *   using the --noSave option. Eddie will not prompt to save on quit.
* Multiple bug fixes including:
   * - Fixed a bug where recent search strings menu picked off-by-one
   * - Some fixes in prototyper white space settings.
   * - Fixed a problem where text at the end of a shell document would randomly start getting colored as a comment.
   * - Fixed problems with upper-ASCII character handling in the Find dialog
   * - Proper menu item enabling
   * - Rudimentary Unicode and Unicode Little Endian handling (limited char set for now).
	
##### Version 0.9.2 Beta
* Find selection flash-highlights
* Combo box for Tab size settings now allows wider range of values.
* Reworked Cmd-Ctrl-Up/DownArrow to drag a non-empty selection up/down (still drags
* entire lines if the selection is empty or spans multiple lines).
* Enhancements to the Swap Left/Swap Right function.
* Enhancements to the Swap feature
   * - recognizes more swappable patterns
   * - flash-highlights swapped strings
* Added some color schemes.
* Fixed some bugs
   * - infinite loop when replace all with wrapping on.
   * - undo in split pane window sometimes doesn't update properly.
   * - Don't crash if $HOME is empty for whatever reason
   * - Better behavior of "Find Whole Word" if search pattern begins or ends with word breaking characters.
   * - Fixed a bug in syntax-coloring HTLM tags.
	
##### Version 0.9.1 Beta
* Better focus/keyboard handling in symbol completion popup window
* Sheet alerts
* Fix some bugs (Shell output Undo handling, reopening Worksheet when the user closed it and more)
	

##### Version 0.9 Beta
* ObjC support in function popup.
* Perl function popup.
* Lua syntax coloring and function popup.
* Optional Symbol auto-completion.
* Better handling of documents changing underneath us.
* General prefs pane.
* Fixed a deadlock in Replace All.
* Added "Replace all in selection", available by pressing the Option key.
* Xcode integration -- made Xcode search results window properly select the matched pattern in Eddie.

##### Version 0.8.3 Beta
* Add a preference to choose whether to use PATH during Tab completion or not.
* Sped up large document opening.
* Save font preference properly.
* Treat executing selected text more like MPW -- don't change the selection unless there is some output.
* Added MPW-like page scroll.
* Make shell output not scroll horizontally and only scroll vertically if the user is not interacting with the scrollbars, etc.
* Remember line ending styles and preserve them when saving, allow setting line endings style in Document settings.
	
Beta 0.8.2 changes:
* Proxy icon popup now works for the Worksheet window and STL headers.
* Tab completion now respects $PATH.
* Bug fixes.

Beta 0.8.1 changes:
* Fixed a bug that made it difficult to edit text in Preferences.

Beta 0.8 changes:
* Application preferences.
* Prototyper whitespace configuration.
* Declaration improvements -- auto update tags as needed, auto-generate tags, preferences, separate definition and declaration lookup using different keyboard shortcuts, menu items and click combos.
* Use Declaration to help find files with Cmd-D.
* Cmd-D for don't save in alerts.
* Don't draw one button at a time when minimizing windows.
* Support Perl in Commenter.
* Don't keep file descriptors open (fixes problem where perl script won't execute when opened in Eddie).
* Fixed several bugs conspiring to Multi-file find not working too well, fix Cmd-Shift-T.
* Fixed #pragma mark handling in function popup
* New primitives UpArrowSingleLineScroll and DownArrowSingleLineScroll
* Optional per-document tab settings
* Xcode, CW integration -- can be used as an external editor.
* Fix some problems with handling •, ™, etc. in the Find dialog.
* New OpenInPreferredEditor primitive and menu item -- great for opening .html files in Safari, etc.
* Function popup now works better with javascript files.
* Grab hand scrolling.
* Documentation (Help->Eddie Help).
